package dev.shadowsoffire.apotheosis.adventure.affix.reforging;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import com.mojang.blaze3d.systems.RenderSystem;
import com.mojang.blaze3d.vertex.PoseStack;
import dev.shadowsoffire.apotheosis.adventure.Adventure;
import dev.shadowsoffire.apotheosis.adventure.affix.reforging.ReforgingMenu;
import dev.shadowsoffire.apotheosis.adventure.affix.salvaging.SalvagingScreen;
import dev.shadowsoffire.apotheosis.adventure.client.AdventureContainerScreen;
import dev.shadowsoffire.apotheosis.adventure.client.GhostVertexBuilder;
import java.util.ArrayList;
import java.util.List;
import net.minecraft.ChatFormatting;
import net.minecraft.client.gui.GuiGraphics;
import net.minecraft.client.resources.sounds.SimpleSoundInstance;
import net.minecraft.client.resources.sounds.SoundInstance;
import net.minecraft.network.chat.CommonComponents;
import net.minecraft.network.chat.Component;
import net.minecraft.network.chat.MutableComponent;
import net.minecraft.resources.ResourceLocation;
import net.minecraft.sounds.SoundEvent;
import net.minecraft.util.Mth;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.world.entity.player.Player;
import net.minecraft.world.inventory.AbstractContainerMenu;
import net.minecraft.world.inventory.Slot;
import net.minecraft.world.item.Item;
import net.minecraft.world.item.ItemStack;

public class ReforgingScreen extends AdventureContainerScreen<ReforgingMenu> {
  public static final ResourceLocation TEXTURE = new ResourceLocation("apotheosis", "textures/gui/reforge.png");
  
  public static final ResourceLocation ANIMATED_TEXTURE = new ResourceLocation("apotheosis", "textures/gui/reforge_animation.png");
  
  public static final int MAX_ANIMATION_TIME = 8;
  
  protected boolean hasMainItem = false;
  
  protected int animationTick = 0;
  
  protected int maxSlot = -1;
  
  protected int opacityTick = 0;
  
  protected int availableOpacity = 170;
  
  public ReforgingScreen(ReforgingMenu menu, Inventory inv, Component title) {
    super((AbstractContainerMenu)menu, inv, title);
    this.f_97727_ = 266;
  }
  
  public void m_88315_(GuiGraphics gfx, int mouseX, int mouseY, float pPartialTick) {
    m_280273_(gfx);
    super.m_88315_(gfx, mouseX, mouseY, pPartialTick);
    RenderSystem.disableBlend();
    m_280072_(gfx, mouseX, mouseY);
    int sigils = ((ReforgingMenu)this.f_97732_).getSigilCount();
    int mats = ((ReforgingMenu)this.f_97732_).getMatCount();
    int levels = ((ReforgingMenu)this.f_97732_).player.f_36078_;
    for (int idx = 0; idx < 3; idx++) {
      Slot slot = ((ReforgingMenu)m_6262_()).m_38853_(3 + idx);
      if (m_6774_(slot.f_40220_, slot.f_40221_, 16, 16, mouseX, mouseY)) {
        ItemStack choice = slot.m_7993_();
        if (!choice.m_41619_()) {
          List<Component> tooltips = new ArrayList<>();
          int sigilCost = ((ReforgingMenu)this.f_97732_).getSigilCost(idx);
          int matCost = ((ReforgingMenu)this.f_97732_).getMatCost(idx);
          int levelCost = ((ReforgingMenu)this.f_97732_).getLevelCost(idx);
          boolean creative = this.f_96541_.f_91074_.m_7500_();
          tooltips.add(Component.m_237115_("text.apotheosis.reforge_cost").m_130944_(new ChatFormatting[] { ChatFormatting.YELLOW, ChatFormatting.UNDERLINE }));
          tooltips.add(CommonComponents.f_237098_);
          if (sigilCost > 0)
            tooltips.add(Component.m_237110_("%s %s", new Object[] { Integer.valueOf(sigilCost), ((Item)Adventure.Items.SIGIL_OF_REBIRTH.get()).m_7626_(ItemStack.f_41583_) }).m_130940_((creative || sigils >= sigilCost) ? ChatFormatting.GRAY : ChatFormatting.RED)); 
          if (matCost > 0)
            tooltips.add(Component.m_237110_("%s %s", new Object[] { Integer.valueOf(matCost), ((ReforgingMenu)this.f_97732_).m_38853_(1).m_7993_().m_41786_().getString() }).m_130940_((creative || mats >= matCost) ? ChatFormatting.GRAY : ChatFormatting.RED)); 
          String key = (idx == 0) ? "container.enchant.level.one" : "container.enchant.level.many";
          tooltips.add(Component.m_237110_(key, new Object[] { Integer.valueOf(idx + 1) }).m_130940_((creative || levels >= levelCost) ? ChatFormatting.GRAY : ChatFormatting.RED));
          tooltips.add(Component.m_237113_(" "));
          tooltips.add(Component.m_237110_("container.enchant.level.requirement", new Object[] { Integer.valueOf(levelCost) }).m_130940_((creative || levels >= levelCost) ? ChatFormatting.GRAY : ChatFormatting.RED));
          drawOnLeft(gfx, tooltips, getGuiTop() + 45);
          break;
        } 
      } 
    } 
  }
  
  protected void m_7286_(GuiGraphics gfx, float partials, int x, int y) {
    int left = getGuiLeft();
    int top = getGuiTop();
    int xCenter = (this.f_96543_ - this.f_97726_) / 2;
    int yCenter = (this.f_96544_ - this.f_97727_) / 2;
    gfx.m_280163_(TEXTURE, xCenter, yCenter, 0.0F, 0.0F, this.f_97726_, this.f_97727_, 256, 384);
    for (int idx = 0; idx < 3; idx++) {
      if (this.maxSlot >= idx && this.animationTick == 0)
        gfx.m_280163_(TEXTURE, left + 20 + 46 * idx, top + 129, (20 + 46 * idx), 273.0F, 46, 35, 256, 384); 
    } 
    boolean hadItem = this.hasMainItem;
    this.hasMainItem = ((ReforgingMenu)this.f_97732_).m_38853_(0).m_6657_();
    if (!hadItem && this.hasMainItem) {
      this.animationTick = 8;
      this.f_96541_.m_91106_().m_120367_((SoundInstance)SimpleSoundInstance.m_119755_((SoundEvent)Adventure.Sounds.REFORGE.get(), 1.0F, 2.0F));
    } 
    if (this.hasMainItem) {
      float delta = Mth.m_14036_(((8 - this.animationTick) - partials) / 8.0F, 0.0F, 1.0F);
      int frame = Mth.m_269140_(delta, 0, 20);
      gfx.m_280411_(ANIMATED_TEXTURE, left + 26, top + 15, 127, 112, 0.0F, (frame * 112), 127, 112, 127, 2240);
    } 
    int sigils = ((ReforgingMenu)this.f_97732_).getSigilCount();
    int mats = ((ReforgingMenu)this.f_97732_).getMatCount();
    int levels = ((ReforgingMenu)this.f_97732_).player.f_36078_;
    this.maxSlot = -1;
    for (int i = 0; i < 3; i++) {
      Slot slot = ((ReforgingMenu)m_6262_()).m_38853_(3 + i);
      if (!slot.m_6657_())
        break; 
      int sigilCost = ((ReforgingMenu)this.f_97732_).getSigilCost(i);
      int matCost = ((ReforgingMenu)this.f_97732_).getMatCost(i);
      int levelCost = ((ReforgingMenu)this.f_97732_).getLevelCost(i);
      if ((sigils >= sigilCost && levels >= levelCost && mats >= matCost) || (this.f_96541_.f_91074_.m_150110_()).f_35937_)
        this.maxSlot++; 
    } 
  }
  
  protected int darken(int rColor, int factor) {
    int r = rColor >> 16 & 0xFF, g = rColor >> 8 & 0xFF, b = rColor & 0xFF;
    r /= factor;
    g /= factor;
    b /= factor;
    return r << 16 | g << 8 | b;
  }
  
  protected void drawBorderedString(GuiGraphics gfx, String str, int x, int y, int color, int shadowColor) {
    MutableComponent mutableComponent = Component.m_237113_(str);
    gfx.m_280614_(this.f_96547_, (Component)mutableComponent, x, y - 1, shadowColor, false);
    gfx.m_280614_(this.f_96547_, (Component)mutableComponent, x - 1, y, shadowColor, false);
    gfx.m_280614_(this.f_96547_, (Component)mutableComponent, x, y + 1, shadowColor, false);
    gfx.m_280614_(this.f_96547_, (Component)mutableComponent, x + 1, y, shadowColor, false);
    gfx.m_280614_(this.f_96547_, (Component)mutableComponent, x, y, color, false);
  }
  
  public boolean m_6375_(double pMouseX, double pMouseY, int pButton) {
    int i = (this.f_96543_ - this.f_97726_) / 2;
    int j = (this.f_96544_ - this.f_97727_) / 2;
    for (int k = 0; k < 3; k++) {
      double d0 = pMouseX - (i + 60);
      double d1 = pMouseY - (j + 14 + 19 * k);
      if (d0 >= 0.0D && d1 >= 0.0D && d0 < 108.0D && d1 < 19.0D && ((ReforgingMenu)this.f_97732_).m_6366_((Player)this.f_96541_.f_91074_, k)) {
        this.f_96541_.f_91072_.m_105208_(((ReforgingMenu)this.f_97732_).f_38840_, k);
        return true;
      } 
    } 
    return super.m_6375_(pMouseX, pMouseY, pButton);
  }
  
  protected void m_181908_() {
    this.opacityTick++;
    if (this.animationTick > 0) {
      this.animationTick--;
      if (this.animationTick == 0)
        this.opacityTick = 0; 
    } 
    float sin = Mth.m_14031_(this.opacityTick / 60.0F * 3.1415927F);
    float delta = sin * sin;
    this.availableOpacity = Mth.m_269140_(delta, 136, 221);
  }
  
  public void m_280092_(GuiGraphics gfx, Slot slot) {
    if (slot instanceof ReforgingMenu.ReforgingResultSlot) {
      if (this.animationTick == 0) {
        int opacity = (this.maxSlot >= slot.m_150661_()) ? this.availableOpacity : 64;
        PoseStack pose = gfx.m_280168_();
        pose.m_85836_();
        pose.m_252880_(0.0F, 0.0F, 100.0F);
        SalvagingScreen.renderGuiItem(gfx, slot.m_7993_(), slot.f_40220_, slot.f_40221_, GhostVertexBuilder.makeGhostBuffer(opacity));
        pose.m_85849_();
      } 
    } else {
      super.m_280092_(gfx, slot);
    } 
  }
}
